﻿using AdventOfCode.Models;
using System;
using System.Linq;

namespace AdventOfCode.Common
{
    public class IgnoreTestAnswerAttribute : Attribute
    {
        private AOCVersion[] _versions;
        public IgnoreTestAnswerAttribute(params AOCVersion[] versions)
        {
            this._versions = versions;
        }

        public bool ShouldIgnoreAnswer(AOCVersion version)
        {
            return _versions.Any(x => x == version);
        }
    }
}
