﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace AdventOfCode._2022.Day7
{
    public class ConsoleCommand
    {
        public string DirectoryTarget { get; set; }
        public List<DirectoryResult> DirectoryResult { get; set; }
        public ConsoleCommand(IEnumerable<string> commands)
        {
            ParseCommand(commands);
        }

        private void ParseCommand(IEnumerable<string> commands)
        {
            var cmd = commands.First(x => x.StartsWith("$"));
            if (cmd == "$ ls")
            {
                DirectoryResult = new List<DirectoryResult>();
                foreach (var dirResult in commands.Where(x => !x.StartsWith("$")))
                {
                    DirectoryResult.Add(new _2022.Day7.DirectoryResult(dirResult));
                }
            }else if (cmd.Contains("cd "))
            {
                DirectoryTarget = cmd.Split(" ")[2];
            }
        }

        public bool IsList()
        {
            return DirectoryResult != null;
        }
    }
}
