﻿using AdventOfCode.Common;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace AdventOfCode._2022.Models
{
    public class CleaningSection
    {
        public int Starting { get; set; }
        public int Ending { get; set; }
        public CleaningSection(string section)
        {
            var split = section.Split("-");
            Starting = split[0].ToInt();
            Ending = split[1].ToInt();
        }
    }

    public class CleaningSectionTask
    {
        private readonly CleaningSection firstSection;
        private readonly CleaningSection secondSection;
        public CleaningSectionTask(string taskList)
        {
            var cleaningSections = taskList.Split(",");
            firstSection = new CleaningSection(cleaningSections[0]);
            secondSection = new CleaningSection(cleaningSections[1]);
        }

        public bool IsOneSectionFullyOverlapped()
        {
            if (firstSection.Starting >= secondSection.Starting && firstSection.Ending <= secondSection.Ending)
                return true;
            if (secondSection.Starting >= firstSection.Starting && secondSection.Ending <= firstSection.Ending)
                return true;
            return false;
        }

        public bool IsAnySectionOverlapped()
        {
            if (firstSection.Starting >= secondSection.Starting && firstSection.Starting <= secondSection.Ending) return true;
            if (firstSection.Ending >= secondSection.Starting && firstSection.Ending <= secondSection.Ending) return true;

            if (secondSection.Starting >= firstSection.Starting && secondSection.Starting <= firstSection.Ending) return true;
            if (secondSection.Ending >= firstSection.Starting && secondSection.Ending <= firstSection.Ending) return true;
            return false;
        }
    }
}
